<template>
  <div>
    <Toolbar :handle-submit="sendForm" :handle-reset="resetForm" />
    <AdminPromoCodeForm
      ref="updateForm"
      v-if="promoC"
      :values="promoC"
      :isLoading="isLoading"
      :errors="violations"
    />
    <Loading :visible="isLoading || deleteLoading" />
  </div>
</template>

<script>
import { mapActions } from "vuex";
import { mapFields } from "vuex-map-fields";
import AdminPromoCodeForm from "../../../components/admin/promo-code/Form.vue";
import Loading from "../../../components/Loading";
import Toolbar from "../../../components/Toolbar";
import UpdateMixin from "../../../mixins/UpdateMixin";

const servicePrefix = "PromoCode";

export default {
  name: "PromoCodeUpdate",
  servicePrefix,
  mixins: [UpdateMixin],
  components: {
    Loading,
    Toolbar,
    AdminPromoCodeForm
  },
  data() {
    return {
      promoC: {}
    };
  },
  watch: {
    promoCodeLoaded(val) {
      if (val) {
        this.promoC = this.promoCode;
      }
    }
  },
  computed: {
    ...mapFields("promoCode", {
      deleteLoading: "isLoading",
      isLoading: "isLoading",
      error: "error",
      updated: "updated",
      violations: "violations"
    }),
    ...mapFields("adminPromoCode", {
      promoCode: "promoCode",
      promoCodeLoaded: "promoCodeLoaded"
    })
  },
  mounted: function() {
    this.$nextTick(function() {
      this.getPromoCode(location.pathname.split("/")[3]);
    });
  },
  methods: {
    ...mapActions("adminPromoCode", ["getPromoCode", "updatePromoCode"]),
    sendForm() {
      console.log(this.promoCode);
      this.updatePromoCode(this.promoCode).then(() => {
        this.showMessage("Élément modifié.");
        this.$router.push({ name: "PromoCodeList" });
      });
    }
  }
};
</script>
